Merge branch 'vendor/LIBRESSL'
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 4.6 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 CS, EX AND VX DRIVERS REMOVED
16 -----------------------------
17
18 The cs(4), ex(4) and vx(4) drivers have been removed. They were very
19 old and its doubtful they ever worked properly in x86_64 but they were
20 in X86_64_GENERIC, so custom configurations derived from it have to be
21 adjusted.
22
23 +-----------------------------------------------------------------------+
24 +         UPGRADING DRAGONFLY FROM 4.4 TO LATER VERSIONS                +
25 +-----------------------------------------------------------------------+
26
27 AMD REMOVED
28 -----------
29
30 The am-utils automounter suite has been removed. It stopped working
31 at some point and was never fixed. autofs(5) and the associated
32 userland has been brought in from FreeBSD and replaces it.
33
34 AN DRIVER REMOVED
35 -----------------
36
37 The an(4) driver has been removed. It was in the X86_64_GENERIC kernel
38 config file, so any configurations derived from it have to be adjusted.
39
40 /DEV/DRI GROUP CHANGED
41 ----------------------
42
43 The default group assigned to /dev/dri entries has been changed
44 from 'wheel' to 'video' with the id of '44'. If you want to have
45 access to the dri devices please add yourself to the video group
46 with:
47
48 # pw groupmod video -m $USER
49
50 +-----------------------------------------------------------------------+
51 +         UPGRADING DRAGONFLY FROM 4.2 TO LATER VERSIONS                +
52 +-----------------------------------------------------------------------+
53
54 DSCHED REMOVED
55 --------------
56
57 dsched(4) has been removed and one of its kernel options, DSCHED_FQ, was
58 in our default kernel config file. So the DSCHED_FQ option has been turned
59 into a no-op for now and can be removed from custom configurations.
60
61 EST DRIVER REMOVED, COMPILE_ET AND LIBCOM_ERR TOO
62 -------------------------------------------------
63
64 The est(4) driver has been removed. All CPUs it supported (except one)
65 were 32 bits only. Those who are still using the Core 2 Duo T7500 should
66 report back if there are any issues with this CPU and our regular ACPI
67 P-state support.
68
69 Also, compile_et(1) and com_err(3) have been removed as well. They
70 should have been removed along with kerberos support, back in 2009.
71
72 SEVERAL LOCALES RENAMED
73 -----------------------
74
75 Several locales were using obsolete and misleading names, and thus have
76 been adjusted to current standards. Any users of the following locales
77 need to select alternates:
78
79 DFLY 4.2 locale            DFLY 4.4 alterative locale
80 ---------------            ------------------------------------
81 mn_MN.UTF-8                mn_Cyrl_MN.UTF-8
82 no_NO.UTF-8                nb_NO.UTF-8      or nn_NO.UTF-8
83 no_NO.ISO8859-1            nb_NO.ISO8869-1  or nn_NO.ISO8859-1
84 no_NO.ISO8859-15           nb_NO.ISO8859-15 or nn_NO.ISO8859-15
85 sr_YU.UTF-8                sr_Cyrl_RS.UTF-8 or sr_Latn_RS.UTF-8
86 sr_YU.ISO8859-5            sr_Cyrl_RS.ISO8859-5
87 sr_YU.ISO8859-2            sr_Latn_RS.ISO8859-2
88 zh_CN.GBK                  zh_Hans_CN.GBK
89 zh_CN.UTF-8                zh_Hans_CN.UTF-8
90 zh_CN.eucCN                zh_Hans_CN.eucCN
91 zh_CN.GB2312               zh_Hans_CH.GB2312
92 zh_CN.GB18030              zh_Hans_CH.GB18030
93 zh_HK.Big5HKSCS            zh_Hant_HK.Big5HKSCS
94 zh_HK.UTF_8                zh_Hant_HK.UTF-8
95 zh_TW.Big5                 zh_Hant_TW.Big5
96 zh_TW.UTF-8                zh_Hant_TW.UTF-8
97
98 +-----------------------------------------------------------------------+
99 +         UPGRADING DRAGONFLY FROM 4.0 TO LATER VERSIONS                +
100 +-----------------------------------------------------------------------+
101
102 BINUTILS 2.25 REPLACES 2.22, PRIMARY
103 ------------------------------------
104
105 The oldest of the two versions of Binutils, version 2.22, was removed
106 and replaced with Binutils 2.25.  It becomes the primary version version
107 of binutils and version 2.24 becomes the alternate.  There are 8 current
108 CVE written against 2.24, so for security reasons version 2.25 should
109 always be used.
110
111 The accepted values of BINUTILSVER are now "binutils225" (default) and
112 "binutils224".  The building of Binutils 2.24 can be prevented by setting
113 NO_ALTBINUTILS=yes in make.conf.
114
115 LOADER OPTIONS CHANGED
116 ----------------------
117
118 Right after the development branch started, the Fred art accompanying the
119 loader menu was improved.  The line between Fred and the menu was removed
120 by default (but can optionally be returned) and the placement shifted as
121 a result.  The drawing was improved, and the colored version was improved,
122 changing the eyes and wing color from white to red.  A new color version
123 of Fred was added, one with a blue scheme.
124
125 The loader menu defaults have changed since release 4.0:  The vertical
126 line was removed, the loader is displayed in color by default*, and the
127 blue scheme is used.
128
129 The loader.conf changes are:
130 loader_color:   option has been removed
131 loader_plain:   option has been added, it changed menu to monochrome
132 fred_is_red:    changes color scheme from blue to red
133 fred_is_blue:   option existed only on 4.1, it has been removed
134 fred_separated: Adds line between Fred and menu (as seen previously)
135
136 * If loader.conf defines "console" as "comconsole" or "console" is defined
137   in the environment as "comconsole" then color will not be displayed,
138   even if loader_plain value is "NO".
139
140 SENDMAIL REMOVED FROM BASE
141 --------------------------
142
143 The only Mail Transfer Agent provided now is DragonFly Mail Agent (dma).
144 If the system being upgraded is still configured to use the sendmail
145 binaries from base, the "make upgrade" command will fail.
146
147 The administrator must change /etc/mail/mailer.conf to switch the
148 mailwrapper to dma or a DPorts-based MTA prior to running the upgrade
149 command that permanently removes sendmail executables and could
150 potentially break a running mail server.
151
152 Refer: http://www.dragonflybsd.com/docs/docs/newhandbook/mta/ for
153 detailed instructions on how to configure the MTA selection.
154
155 _KPOSIX_VERSION and P1003_1B OPTIONS REMOVED
156 --------------------------------------------
157
158 The _KPOSIX_VERSION and P1003_1B kernel options have been changed to
159 no-ops. They can be removed from custom kernel configurations.
160
161 SOUND SYSTEM UPDATED FROM FreeBSD 11-CURRENT
162 --------------------------------------------
163
164 Many more sound devices may be detected.
165
166 If the default device choosen isn't to your liking, setting the sysctl
167 hw.snd.default_unit to a different number will change it.
168
169 SCTP SUPPORT DROPPED
170 --------------------
171
172 Support for the SCTP protocol has been removed.
173
174 OLD USB DRIVERS REMOVED
175 -----------------------
176
177 The old USB stack, along with the kernel config option "device oldusb"
178 and the make.conf variable "WANT_OLDUSB" have been removed. This means
179 that for custom kernel configuration files which were derived from a
180 GENERIC or X86_64_GENERIC file prior to making the usb4bsd stack default,
181 various (old USB stack specific) devices will now complain about being
182 unknown:
183
184   * oldusb      (obviously)
185   * natausb     (not yet ported to usb4bsd)
186   * rue         (not yet ported to usb4bsd)
187   * ugen        (no longer needed in usb4bsd)
188   * urio        (not yet ported to usb4bsd)
189   * uscanner    (no longer needed in usb4bsd)
190
191 They should be removed or commented out in such custom kernel configs.
192
193 GCC 5
194 -----
195
196 The GCC 4.4 compiler has been retired.  It has been replaced by a GCC 5.1.
197 The following make.conf variables no longer work: NO_GCC44, NO_OBJC, and
198 NO_CXX.  The latter was never documented and the latest versions of GCC are
199 partially written in C++ so a C++ compiler is no longer optional.  In
200 practical terms it has not been optional for many years as other base
201 components are also written in C++.  The resource savings by avoiding
202 building Objective-C compiler is so small, the complexity added by NO_OBJC
203 internally was deemed a bad tradeoff so that is the reason for its removal.
204 Also note that no "info" pages are installed with GCC 5.  After this entry
205 was originally written, all info pages were removed from DragonFly.
206
207 GCC 5.1 has been designated as the primary compiler.  As such, there is a
208 new make.conf variable, NO_ALTCOMPILER.  It will block the rebuilding of
209 the designated secondary compiler, GCC 4.7.  However, while DPorts
210 primarily uses GCC 5 to build ports now, it still uses GCC 4.7 as well, so
211 if building ports from source is desired, don't block building of the
212 secondary compiler.
213
214 +-----------------------------------------------------------------------+
215 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
216 +-----------------------------------------------------------------------+
217
218 SMP AND DEVICE_POLLING OPTIONS MADE UNKNOWN
219 -------------------------------------------
220
221 DEVICE_POLLING was replaced by IFPOLL_ENABLE and the former SMP code is
222 the default now (even on single-core systems), both for, like, 21 months.
223 We kept the options around as no-ops as a convenience, to allow people
224 using the same config for the then current release and the then current
225 master. That period is now over, so any configs still having those
226 options have to be adjusted.
227
228 SYSVIPC SYSCALLS MADE NON-OPTIONAL
229 ----------------------------------
230
231 The code related to the SYSVMSG, SYSVSEM and SYSVSHM kernel options is
232 now compiled in by default. The options are no-ops for now.
233
234 DEFAULT DRIVER CHANGED FOR LSI "THUNDERBOLT" SERIES RAID CONTROLLERS
235 --------------------------------------------------------------------
236
237 The default driver for those controllers is now mrsas(4) due to reports
238 of file system corruption using the mfi(4) driver. The whole issue (and
239 how to deal with potential problems when switching) was explained here:
240
241 http://lists.dragonflybsd.org/pipermail/users/2014-July/128703.html
242
243 A tunable is provided for letting those controllers still attach via
244 the mfi(4) driver, hw.mrsas.mfi_enable (see mrsas(4) manual page).
245
246 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
247 ----------------------------------------
248
249 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
250 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
251 removed in kernel configs derived from X86_64_GENERIC.
252
253 +-----------------------------------------------------------------------+
254 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
255 +-----------------------------------------------------------------------+
256
257 UPDATE FROM MOST RECENT 3.6
258 ---------------------------
259
260 Versions of 3.6 built before June 25th have a bug where installworld might 
261 crash during installation of the new initrd.  Upgrade to the latest version
262 of 3.6 before updating to 3.8 or later.
263
264 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
265 --------------------------------------
266
267 Support for the IPX and NCP network protocols and for mouting NetWare
268 file systems has been dropped. Dito for ATM protocol support.
269
270 INITRD IMAGES NOW INSTALLED BY DEFAULT
271 --------------------------------------
272
273 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
274
275 Older images installed under the file name of initrd.img will be removed
276 automatically by the make upgrade process.
277
278 USB4BSD IS NOW THE DEFAULT USB STACK
279 ------------------------------------
280
281 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
282 replace "device usb" with "device oldusb" in the kernel configuration.
283
284 MORE ISA SUPPORT DROPPED
285 ------------------------
286
287 ISA support has been dropped from the following drivers: adv(4), an(4),
288 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
289 si(4), sn(4), and stg(4).
290
291 +-----------------------------------------------------------------------+
292 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
293 +-----------------------------------------------------------------------+
294
295 ABI CHANGE
296 ----------
297
298 Installed third-party software (dports) will have to be rebuilt after upgrade,
299 or reinstalled from binary packages.
300
301 UPDATING FROM 3.4 TO 3.6
302 ------------------------
303
304 This only applies for this specific upgrade due to locale changes; it is 
305 not needed for upgrades after 3.6.  Please update in this order:
306
307 make buildworld
308 make buildkernel
309 make installworld
310 make installkernel
311 *reboot*
312 make upgrade
313
314 See this mailing list post for details:
315 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
316
317 CYRIX OPTIONS REMOVED
318 ---------------------
319
320 The following Cyrix related options have been removed: CPU_BTB_EN,
321 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
322 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
323 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
324
325 ISA SUPPORT REMOVED FROM RP(4)
326 ------------------------------
327
328 ISA support has been removed from the rp(4) driver. It is now PCI only.
329
330 +-----------------------------------------------------------------------+
331 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
332 +-----------------------------------------------------------------------+
333
334 COMPAT_SUNOS OPTION REMOVED
335 ---------------------------
336
337 The COMPAT_SUNOS option has been removed. It was meant to provide binary
338 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
339
340 ISA SOUND CARD SUPPORT REMOVED
341 ------------------------------
342
343 The following modules have been removed (all for ISA sound cards):
344 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
345
346 GCC 4.7
347 -------
348
349 DragonFly has switched base compilers.  GCC 4.7 is now the default
350 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
351 variable ceases to work now.
352
353 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
354 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
355 highly discouraged.  There are a few packages in pkgsrc that do not build
356 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
357 this time, it is recommended to keep both compilers on the base system.
358
359 SMP OPTION REMOVED
360 ------------------
361
362 The SMP kernel option has been made a no-op. All kernels now feature SMP
363 support. If you have 'options SMP' in your kernel config, you can as well
364 remove it.
365
366 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
367 ---------------------------------------------------------------------------
368
369 The DEVICE_POLLING kernel option has been made a no-op and it has been
370 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
371 kernel config, you need to change it to IFPOLL_ENABLE.
372
373 Also, the KTR_POLLING kernel option has been removed, so it must be
374 removed from kernel configs that have it.
375
376 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
377 ---------------------------------------------------
378
379 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
380 cards will no longer be detected.
381
382 The same has been done for Stallion multiport serial controllers. stli(4)
383 has been completely removed (along with the stlload(8) and stlstty(8)
384 utilities) and stl(4) was changed to support only PCI cards. Similarly,
385 ISA support was removed from cy(4) too. All these drivers are i386 only.
386
387 COMPAT_OLDISA OPTION GONE
388 -------------------------
389
390 The i386 specific COMPAT_OLDISA kernel option has been removed, since
391 nothing needs it anymore.
392
393 +-----------------------------------------------------------------------+
394 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
395 +-----------------------------------------------------------------------+
396
397 APIC_IO OPTION REMOVED
398 ----------------------
399
400 The APIC_IO kernel option is no longer accepted after having been without
401 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
402 If you have 'options APIC_IO' in your kernel config, you'll have to
403 remove it.
404
405 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
406 -----------------------------------------
407
408 The wdog framework is now compiled into our kernels by default, so the
409 options are no longer needed.
410
411 DOSCMD(1) REMOVED
412 -----------------
413
414 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
415 NO_X make.conf option was removed too.
416
417 GCC 4.7
418 -------
419
420 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
421 default compiler in base (default is still GCC 4.4).
422
423 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
424 NO_GCC47 in /etc/make.conf.
425
426 USB4BSD
427 -------
428
429 A new USB stack (from FreeBSD) has been brought in. The following
430 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
431 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
432 and uaudio.
433
434 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
435 be put in make.conf and device "usb4bsd" (quotes needed) has to
436 replace device usb in the kernel config. After that, a full
437 build/install/upgrade cycle is needed.
438
439 Note that this is experimental and incomplete, but we are interested
440 in hearing about issues with it, of course.
441
442 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
443 ---------------------------------------------
444
445 ISA adapter support was dropped from the aic(4) driver.
446
447 +-----------------------------------------------------------------------+
448 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
449 +-----------------------------------------------------------------------+
450
451 SEVERAL ISA DRIVERS REMOVED
452 ---------------------------
453
454 The following ISA only drivers have been removed along with a couple of
455 associated userland tools:
456
457 aha(4)
458 asc(4) & sasc(1)
459 ctx
460 dgb(4)
461 el(4)
462 gpib
463 gsc(4) & sgsc(1)
464 ie(4)
465 labpc(4)
466 le(4)
467 mse(4)
468 rc(4)
469 rdp(4)
470 spigot
471 tw(4) & xten(1) & xtend(8)
472 wl(4) & wlconfig(8)
473 wt(4)
474
475 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
476 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
477 file.
478
479 If buildkernel complains about any of these drivers, just remove them
480 from your kernel configuration.
481
482 BINUTILS 2.20
483 -------------
484 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
485 values of BINUTILSVERS are now binutils221 and binutils222 (default).
486
487 BUILDWORLD/-KERNEL PARALLELIZATION WORK
488 ---------------------------------------
489 Due to changes in the way we build with more than one make job, you
490 will have to update install(1) and mkdir(1) prior to buildworld if you
491 want to build with 'make -j':
492
493 cd /usr/src/usr.bin/xinstall; make; make install; make clean
494 cd /usr/src/bin/mkdir; make; make install; make clean
495
496 DMA(8) UPGRADE
497 --------------
498 dma(8) has been upgraded to v0.7 which no longer supports the
499 /etc/dma/virtusertable. Some of its functionality has been replaced
500 with the MASQUERADE keyword and the EMAIL environment variable (see
501 the dma(8) manual page).
502
503 +-----------------------------------------------------------------------+
504 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
505 +-----------------------------------------------------------------------+
506
507 GCC 4.4 & BINUTILS 2.21
508 -----------------------
509
510 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
511 been made DragonFly's default Binutils.
512
513 That means that any settings that set CCVER to 'gcc44' are not needed
514 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
515 GCC 4.1.
516
517 It also means that 'binutils221' as a value for BINUTILSVER has no
518 effect anymore. 2.17 has been removed and 'binutils220' is available
519 as an option.
520
521 The NO_GCC44 option has been removed and will not affect the build
522 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
523 building in a similar fashion.
524
525 Note that you must do a full buildworld/buildkernel for upgrading.
526
527 pkg_radd settings
528 -----------------
529
530 The config file for pkg_radd has moved from /etc/settings.conf to 
531 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
532 if this is needed.  This warning only applies if /etc/settings.conf 
533 exists.  pkg_radd will continue to work with defaults.
534
535 +-----------------------------------------------------------------------+
536 +         20100927                                                      +
537 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
538 +-----------------------------------------------------------------------+
539
540 OpenSSL
541 --------
542
543 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
544 This shouldn't break any 3rd-party software, but you'll need to recompile your
545 3rd-party software if you want it to link against the new version of OpenSSL.
546
547 Loader
548 -------
549
550 A new loader (dloader) has been added which better handles booting from
551 multiple kernel/module versions.
552
553 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
554
555         cd /usr/src
556         make buildworld
557         make installworld
558         make upgrade
559         make buildkernel KERNCONF=<KERNELNAME>
560         make installkernel KERNCONF=<KERNELNAME>
561
562 Note that you must installworld and run the 'upgrade' target before
563 installing the new kernel.
564
565 BIND
566 -----
567
568 BIND has been removed from the base system.  The ldns and drill tools have 
569 been added for basic functionality.  Use 'drill' where you would normally 
570 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
571 net/bind95, net/bind96, or net/bind97 as of this writing.
572
573 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
574 include BIND as a pkgsrc package.
575
576 +-----------------------------------------------------------------------+
577 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
578 +                               GENERAL                                 +
579 +-----------------------------------------------------------------------+
580
581 Instructions on how to obtain and maintain DragonFly source code using git
582 are in the development(7) manual page.
583
584 To upgrade a DragonFly system from sources you run the following sequence:
585
586         cd /usr/src
587         make buildworld
588         make buildkernel KERNCONF=<KERNELNAME>
589         make installkernel KERNCONF=<KERNELNAME>
590         make installworld
591
592 You will also want to run the 'upgrade' target to upgrade your /etc and the
593 rest of your system.  The upgrade target is aware of stale files created by
594 older DragonFly installations and should delete them automatically.
595
596         make upgrade
597
598 See the build(7) manual page for further information.
599
600 Once you've done a full build of the world and kernel you can do incremental
601 upgrades of either by using the 'quickworld' and 'quickkernel' targets
602 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
603 the quick targets, try updating your repo first, and then a full buildworld
604 and buildkernel as shown above, before asking for help.
605
606 +-----------------------------------------------------------------------+
607 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
608 +-----------------------------------------------------------------------+
609
610 In 2.1 kernel and modules has moved to boot directory.  For most cases
611 this is handled automatically by 'make upgrade'.  A few cases needs manual
612 intervention:
613
614  * When installing a kernel without first doing a make buildworld,
615    installworld and upgrade to the same DESTDIR as kernel:
616    make DESTDIR/boot directory and move kernel and modules into this boot
617    directory; also move kernel.old and modules.old.
618    Typical example is vkernel(7), use (no modules used):
619
620         cd /var/vkernel
621         mkdir boot
622         chflags noschg kernel
623         mv kernel kernel.old boot
624         chflags schg boot/kernel
625         
626  * When using a boot-only partition, /boot/loader.rc needs to be edited:
627    delete occurrences of '/boot/'.
628    These occurences can normally be deleted in any case, see loader(8).
629
630 +-----------------------------------------------------------------------+
631 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
632 +-----------------------------------------------------------------------+
633
634 In 1.9 major changes to the disk management infrastructure have taken
635 place.  make upgrade may not catch all of your disk devices in /dev,
636 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
637 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
638 and MAKEDEV no longer exists.
639
640 The biggest changes in 1.9 are:
641
642 (1) That whole-slice devices such as da0s1 no longer share the same device
643     id as partition c devices such as da0s1c.
644
645 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
646     with no snooping or reserved sectors.  Consequently you cannot run
647     disklabel on this device.  Instead you must run disklabel on a
648     whole-slice device.
649
650 (3) The 'compatibility' partitions now use slice 0 in the device name,
651     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
652     accessing the disklabel for the compatibility partitions must be
653     done via slice 0 (da0s0).
654
655 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
656     and CCD now run through the disk management layer and are assigned
657     real disk management devices.   VN and CCD in particular do not usually
658     use a MBR and disklabels must be accessed through the compatibility
659     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
660     don't name it 'ccd0s0' in the config file.
661
662 Generally speaking, you have to get used to running fdisk and disklabel on
663 the correctly specified device names.  A lot of the wiggle, such as running
664 disklabel on a partition, has been removed.
665
666 +-----------------------------------------------------------------------+
667 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
668 +-----------------------------------------------------------------------+
669
670 > Kerberos IV
671 -------------
672
673 Kerberos IV (eBones) was removed from the tree, please consider moving to
674 Kerberos 5 (Heimdal).
675
676 > Package Management System
677 ---------------------------
678
679 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
680 management system.  The necessary tools to build and maintain packages
681 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
682 directories are in your PATH variable.
683
684 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
685 the tarball from NetBSD:
686
687         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
688         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
689
690 This tree can then be kept up to date with cvs update:
691
692         cd /usr/pkgsrc; cvs up
693
694 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
695 build and install the pkgsrc bootstrap manually:
696
697         cd /usr/pkgsrc/bootstrap
698         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
699
700 +-----------------------------------------------------------------------+
701 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
702 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
703 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
704 +-----------------------------------------------------------------------+
705
706 The compatibility shims for the build environment have been removed, you
707 have to update to DragonFly 1.2 release branch first.
708
709 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
710 The existing configuration can be converted using /etc/pam.d/convert.sh.
711 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
712 the pam_skey.so module was retired, you have to remove it manually from
713 your configuration, when you convert it.
714
715 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
716 ---------------------
717
718 The following users may be missing from your password file.  Use vipw and
719 add any that are missing:
720
721 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
722 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
723
724 The following groups may be missing from your group file.  Use vi /etc/group
725 and add any that are missing:
726
727 smmsp:*:25:
728 authpf:*:63:
729 _pflogd:*:64:
730
731
732 > Upgrading to DragonFly from FreeBSD
733 ---------------------
734
735 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
736 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
737 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
738 make depend information, it starts from scratch, so no pre-cleaning of the
739 object hierarchy is necessary.
740
741         # get the CVS repository (it is placed in /home/dcvs, 500MB).
742         # Please use the -h option and a mirror site to pull the 
743         # initial repository, but feel free to use the main repository
744         # machine to pull updates.
745         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
746         # install the source from the CVS hierarchy (remove preexisting
747         # FreeBSD src first) (500MB)
748         cd /usr
749         rm -rf src
750         cvs -R -d /home/dcvs checkout -P src
751
752         # build it (500MB used in /usr/obj)
753         #
754         cd /usr/src
755         make buildworld
756         make buildkernel KERNCONF=<KERNELNAME>
757
758 Once you have built DragonFly you have to install it over FreeBSD.  Since
759 DragonFly does not track changes made by FreeBSD to its include file 
760 hierarchy and include file pollution can cause all sorts of unexpected
761 compilation issues to come up, it is best to wipe your include hierarchy
762 prior to installing DragonFly.  Note that you should not wipe any installed
763 FreeBSD header files or binaries until after you have successfully completed
764 the build steps above.
765
766         rm -rf /usr/include
767         mkdir /usr/include
768         make installkernel KERNCONF=<KERNELNAME>
769         make installworld
770
771 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
772 will unconditionally upgrade the /etc files that sysops do not usually
773 mess around with, such as the files in /etc/rc.d.  It will also remove any
774 obsolete files such as utilities and manpages that have been removed from
775 the system since the version you're coming from.  If you are unsure we 
776 recommend that you make a backup of at least your /etc before applying
777 this step.  Note that DragonFly's RC system is basically RCNG from
778 FreeBSD-5, but there are some differences in the contents of the RC files.
779
780         make upgrade
781
782 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
783 Doing so might leave your system in an unusable state.
784
785 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
786 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
787 report these files to the DragonFly developers so that they can be added to
788 the 'upgrade' target.
789